// JavaScript Document

var styleChanger = true; // flag

// name(label), styleSheet url
var styles = [
	['White', 'StyleSheets/Default/playerColor.css'],
	['Black', 'StyleSheets/Black/playerColor.css'],
	['Yellow', 'StyleSheets/Yellow/playerColor.css'],
	['BlueOnWhite', 'StyleSheets/BlueOnWhite/playerColor.css']
];

function getPageStyleSelectorElem()
{
	return document.getElementById('pageStyleSelector');
}

function getStyleVariantLinkElem()
{
	return document.getElementById('variantCss');
}

function changeVariantStyleUrl(url, elem)
{
	if (!elem)
	  elem = getStyleVariantLinkElem();
	elem.setAttribute('href', url);
}

function getStyleListControl()
{
	return document.getElementById('listPageStyles');
}

function fillAvailableStyles(elem)
{
	if (!elem)
	  elem = getStyleListControl();
	if (elem)
	{
		elem.options.length = styles.length;
		for (var i = 0, l = styles.length; i < l; ++i)
		{
			elem.options[i].text = styles[i][0];
			elem.options[i].value = styles[i][1];
		}
	}
}

function reactStyleListChange(e)
{
	var ctrl = getStyleListControl();
	var url = ctrl.options[ctrl.selectedIndex].value;
	changeVariantStyleUrl(url);
}

function initChanger()
{
	fillAvailableStyles();
	// show pageStyleSelector
	getPageStyleSelectorElem().style.display = 'block';
	try
	{
		//if (Event && Event.observe)
		{
      Event.observe(getStyleListControl(), 'change', reactStyleListChange);
		}
  }
  catch(e)
  {
    getStyleListControl().onchange = reactStyleListChange;
  }
}

try
{
  Event.observe(document, 'dom:loaded', initChanger);
}
catch(e)
{
	if (window.attachEvent)
	  window.attachEvent('onload', initChanger);
	else
    window.addEventListener('load', initChanger, true);
}