var wsApp;

// Log Panel
var logPanelVisible = false;
function showLogPanel()
{
  //if (Element && Element.show)
  try
  {
    Element.show('logPanel');
    Element.addClassName('navLog', 'Checked');
  }
  //else
  catch(e)
  {
    var elem = document.getElementById('logPanel');
    elem.style.display = '';
    elem.className = 'Checked';
  }
  logPanelVisible = true;  
}
function hideLogPanel()
{
  //if (Element && Element.hide)
  try
  {
    Element.hide('logPanel');
    Element.removeClassName('navLog', 'Checked');
  }
  //else
  catch(e)
  {
    var elem = document.getElementById('logPanel');
    elem.style.display = 'none';
    elem.className = '';
  }
  logPanelVisible = false;
}
function toggleLogPanel()
{
  if (logPanelVisible)
    hideLogPanel();
  else
    showLogPanel();
}

function loggerOnError(message)
{
  showLogPanel();
}

function reactLogCloserClick(e)
{
  hideLogPanel();
  try { Event.stop(e); } catch(e){};
  return false;
}

function reactToggleLogBtnClick(e)
{
  toggleLogPanel();
  try { Event.stop(e); } catch(e){};
  return false;
}

// --- Initial Events -------------------------------------

function prepareAutoZoom(wsApp)
{
  wsApp.setAutoZoomerUsePredefinedRatio(true);
  wsApp.setAutoZoomWidthRatio(1);
  wsApp.setAutoZoomHeightRatio(1);
  wsApp.setFixedSpaceWidth(140);  // sidebar width width gap
  wsApp.setFixedSpaceHeight(20);  // controller height plus mainclient padding
}

function reactWsAppLoaded(e)
{
  if (WebShow.app)
  {
    wsApp = WebShow.app;
    prepareAutoZoom(wsApp);
  }
}

function init()
{
	try  // avoid IE raise exception while designing
	{
		//if (Event && Event.observe)
		{
      Event.observe('logCloser', 'click', reactLogCloserClick);
	    Event.observe(document.documentElement, WebShow.AppLauncher.APP_LAUNCH_EVENT, reactWsAppLoaded);
      
      //installSlideNavEventHandlers();
		}
  }
  catch(e)
  {
    document.getElementById('logCloser').onclick = reactLogCloserClick;
  }
  try
  {
    if (WebShow.Logger)
    {
      WebShow.Logger.element = document.getElementById('wsLog');
      WebShow.Logger.onError = loggerOnError;
    }
    if (WebShow.app)  // already loaded
      reactWsAppLoaded();
  }
  catch(e) {}
}

//if (Event && Event.observe)
try
{
  Event.observe(document, 'dom:loaded', init);
}
catch(e)
{  
  window.onload = init;
}